clear all
clc
Dato='xy.XO'
%Static parameters:
%Flex (if any)
%Alpha(precentage points)
size_alpha_W=90;    %Wholesaler alpha for storable promotions (org 90)
size_alpha_SP_T=90; %Transport alpha for storable promotions (org 90)
size_alpha_SO_T=20; %Transport alpha for storable ordinary (org 30)
%Lag
lag_W=28;           %Wholesaler the whole week (only earlier)
lagSP_Early_T=28;     %Transporter the whole week (only earlier)
lagSP_Late_T=28;      %Transporter the whole week (only later)
lagSO_Early_T=11;     %Transporter 2 days (only earlier) (org 11)
lagSO_Late_T=11;      %Transporter 2 days (only later) (org 11)
%Maxtime
maxtime_W=100;      %Computational time of wholesaler in mosel
%maxtime_T=50;    %Computational time of transport company in mosel, moved down
%Truck parameters
TruckCapacity=60;   %Number of pallets in a truck
TruckCost_Int=1000;  %Cost of using own truck one time
TruckCost_Ext=2000;  %Cost of using rent truck one time
%Renting
maxTrucks=15;       %Maximum number of trucks here!!!
nOwned_Base=8;      %Skal vre 8!!!!!
%Other
samecost=0;         %if 1 then the dummy cost of routes are the same as the main routes, 0 for different costs
nCustomers=39;      %Number of retailers
nRoutes_W=23;       %Number of routes for wholesaler (cut route 8)
nTime=28;           %Number of total time periods

AvarageLevel=125;   %Avarage daily demand     (150)                              -> M FIKSES! M rettes etter paller er rundet opp

MoveCost=0;         %Cost of moving pallet
Time_Base=[1 5 9 13 18 21 22 27];
RouteUsed_W=[];

%Fra Hoveddokument fra Dataprossesering
OrgCost_Int=[420	402	390	380	414	440	435	380	424	460	380	370	399	440	395	570	637	634	395	613	580	520	590];
OrgCost_Ext= OrgCost_Int; %[525	503	488	475	518	550	544	475	530	575	475	463	499	550	494	712	796	793	494	766	725	650	738];
OrgReturnTime=[7	7	6	6	7	7	7	7	7	7	6	6	7	7	6	9	10	11	7	10	9	8	9
    ];

Cost_Pallet=OrgCost_Int/500;    %Cost of pallets      , pallet route cost                                  -> Insentiv, m bestemmes!!!

nBreakpoints=150;
LevelingCost=[1 2 3 4];
Beta=[25 50 75 100];

%Mappeleting
mappe=0;    %change here to change folder

if mappe==1
    filstart='\\tsclient\Z';
    filstart2='\\tsclient\C';
else
    filstart='Z:';
    filstart2='C:';
end

filename=[filstart '\Data\MainDocument.xlsx'];
filename_d=[filstart '\Data\DataInput.xlsx'];
dummy_in=[filstart '\Data\SupplementaryRoutes.xlsx'];
file_I=[filstart '\Data\CapacityRetailer.xlsx'];
Mosel_W=[filstart '\Matlab\Scriptet\WholesalerModel.mos'];
Mosel_T=[filstart '\Matlab\Scriptet\TransporterModel.mos'];
filPrint=[filstart '\Matlab\Scriptet\ToXpress_T.txt'];
filPrint2=[filstart '\Matlab\Scriptet\ToXpress_W.txt'];

%Input for Inventory Capacity
sheet_I=1;
range_I='G3:G41';
InventoryCap=xlsread(file_I,sheet_I,range_I);                              % -> M FIKSES!!!

%Input for main routes
sheet=2;                            %side med data
R_col=2;                            %Kolonne for rute
C_col=8;                            %Kolonne med kunder
Last_col=18;                        %Kolonne med ruteperiode, lastetid
Levering_col=21;                    %Kolonne med kundeperiode, leveringstid
antPerioder=4;                      %antall perioder i dgnet
antDager=7;                         %antall dager: sjekk om vi mangler her!!!
maxPeriode=antPerioder*antDager;    %Hyeste peridode som eksisterer i settet

%Input for returntime trucks
sheet_r=3;                          %sheet med ruteinfo
xlRange_r='N31:W53';                %ruteinforange, denne m gjres riktig
ret_time_col=8;                     %kolonne med antall returperioder
c_int_col=9;                        %kolonne med int rutekost
c_ext_col=10;                       %kolonne med eks rutekost

%Input Dummy
xlRange_dum='A5:S125';
ant_but_range='B2';                      %Antall butikker i ruten range
hovedrute_range='AB3:AB';                %Hovedrute startcelle i excel
nr_ark=24;                               %Ant ark, begynner med ark 1
start_col=5;                             %Kolonne med start butikk
slutt_col=6;                             %Kolonne med sluttbutikk
ret_time_col_dum=17;                     %kolonne med antall returperioder
c_int_col_dum=18;                        %kolonne med int rutekost
c_ext_col_dum=19;                        %kolonne med eks rutekost

%Input for demand
sheet_d=1;          %leveringsinfo
uke_col=19;         %kolonne med uke
period=20;          %kolonne medperiode demanden skal settes til (enten utkjring eller levering)
col_c=4;            %kolonne med debitor (butikk, MatLabID)
col_type=2;         %kolonne med varetype (Vanlig)
col_dem_tot=25;     %kolonne med totale paller (desimal)
col_dem_ord=26;     %kolonne med paller som ikke er kampanje
col_dem_kamp=27;    %kolonne med demand for kampanje
maxPeriode_Dem=28;  %maxperioder med demand (28 hvis lst utkjring)
ceiling=1;          %Ceiling of the demand, set to 1 if integer demand




disp('To abort program, press "ctr+c"');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  WHOLESALER  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
SP_Time_W=[];

%Asking for parameters
[alpha_W info_case week case_str flexW_str B_str maxtime_T]=ask_W(size_alpha_W, lag_W);
if alpha_W==-1||info_case==-1||week==-1||B_str==-1||maxtime_T==-1
    disp('Error when asking for wholesaler parameters');
    return
end

%Creating parameters for routes
[Customers_on_route Routes_of_customer B_matrix A_ir R]=wholesaler_input(filename,sheet,R_col,C_col,Last_col,maxPeriode,Levering_col,B_str,Time_Base);

%Printing parametere
fprintf('\nOther parameters are set to:');
fprintf('\nNumber of Retailers: %d',nCustomers);
fprintf('\nNumber of Routes: %d',nRoutes_W);
fprintf('\nNumber of TimePeriods: %d',nTime);
fprintf('\nCost of deviating pallets: %d',LevelingCost);
fprintf('\nAverage daily Pallets: %d',AvarageLevel);
fprintf('\nCost of moving Pallets: %d',MoveCost);
fprintf('\nMax computational time Wholesaler: %d\nMax computational time Transport Company: %d',maxtime_W,maxtime_T);
fprintf('\nTruck Capacity: %d\nCost of using a truck: %d (Own) %d (Rented)\n',TruckCapacity,TruckCost_Int,TruckCost_Ext);


%Input of Demand
fprintf('Demand is created\n');
[OrgD_NS OrgD_SP OrgD_SO D_Tot D_totceil D_Sum]=wholesaler_demand(filename_d,sheet_d,period,col_c,col_type,col_dem_ord,col_dem_kamp,col_dem_tot,maxPeriode_Dem,uke_col,week,ceiling);
if sum(sum(OrgD_NS))==0||sum(sum(OrgD_SP))==0||sum(sum(OrgD_SO))==0
    disp('Error when creating demand. Demand is zero');
    return
end
fprintf('Demand done\n');

TimeDay=vec2mat(1:28,4);
RouteUsed_W=cell(1,7);
LastInventory=zeros(nCustomers,nTime);

oldpath = path;
path(oldpath,[filstart2 '\Xpressmp\matlab'])
if info_case==1 %Daily-Dayly
    for d=1:7;
        fprintf('\nRunning Wholesaler Daily for day %d',d);
        TimeX=Time_Base(Time_Base>=((d-1)*4+1)&Time_Base<=((d-1)*4+4));
        D_NS=zeros(39,28); D_SP=zeros(39,28); D_SO=zeros(39,28);
        D_NS(:,TimeX)=OrgD_NS(:,TimeX);D_SP(:,TimeX)=OrgD_SP(:,TimeX);D_SO(:,TimeX)=OrgD_SO(:,TimeX);
        Day=d;
        tic;
        moselexec(Mosel_W);
        t_W(d)=toc;
        obj_W(d)=objval;
        optimal_W(d)=optsol;
        Pallets{d}=Pallets_rt;
        SumPall_W(d)=SumP;
        RouteUsedDay_W(:,d)=RouteUsedDay(:,d);
        ySP_W{d}=ySP;
        ySO_W{d}=ySO;
        yNS_W{d}=yNS;
        gap_W(d)=Wgap;
        TimeServedSP_W{d}=SP_Time_W;
        OnInventory{d}=OnI;
        LastInventory=zeros(nCustomers,nTime);
        LastInventory(:,d*4)=OnInventory{d}(:,d*4);          %dobbeltskjekk
        if optimal_W(d)==1
            fprintf('\nThe solution is optimal and has the value: %4.2f\nTime used: %4.2f',obj_W(d),t_W(d));
        else
            fprintf('\nNot optimal solution with value: %4.2f\nTime used: %4.2f',obj_W(d),t_W(d));
        end
    end
    tot_dd=sum(obj_W);
    fprintf('\n\nTotal cost for the week for wholesaler in Daily-Daily information case: %4.2f\n',tot_dd);
else
    D_NS=OrgD_NS; D_SP=OrgD_SP; D_SO=OrgD_SO;
    TimeX=Time_Base;
    Day=-1;
    fprintf('\nRunning Wholesaler Weekly');
    tic;
    moselexec(Mosel_W);
    t_W=toc;
    obj_W=objval;
    optimal_W=optsol;
    Pallets=Pallets_rt;
    SumPall_W=SumP;
    RouteUsedDay_W=RouteUsedDay;
    ySP_W=ySP;
    ySO_W=ySO;
    yNS_W=yNS;
    gap_W=Wgap;
    TimeServedSP_W=SP_Time_W;
    OnInventory=OnI;
    if optimal_W==1
        fprintf('\nThe solution is optimal and has value: %4.2f\nTime used: %4.2f\n',obj_W,t_W);
    else
        fprintf('\nNot optimal solution with value: %4.2f\nTime used: %4.2f\n',obj_W,t_W);
    end
end
path(oldpath)


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  TRANSPORT  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
objval=[];
optsol=0;
ySP=[];
ySO=[];
yNS=[];
RouteUsed_T=[];
d=[];


[alpha_SP, alpha_SO, lagSP_Early, lagSP_Late, lagSO_Early, lagSO_Late, nOwned, dum_r, dep_routes, dep_demand, flexTSP_str, flexTSO_str, flexSP_TELB_str, flexSO_TELB_str, rent_str]=ask_T(size_alpha_SP_T, size_alpha_SO_T,  maxTrucks, nOwned_Base, lagSP_Early_T, lagSP_Late_T, lagSO_Early_T, lagSO_Late_T, info_case);
if alpha_SP==-1|| alpha_SO==-1|| lagSP_Early==-1|| lagSP_Late==-1|| lagSO_Early==-1|| lagSO_Late==-1|| nOwned==-1|| dum_r==-1|| dep_routes==-1||dep_demand==-1
    disp('Error when asking for transporter parameters');
    return
end





string_ex=[filstart '\Resultater\',Dato,'__Case_',upper(case_str),'__Week_',num2str(week),'__FlexW_',upper(flexW_str),'__FlexT_SP_',upper(flexSP_TELB_str),'__FlexT_SO_',upper(flexSO_TELB_str),'__Rent_',upper(rent_str),'__Dummy_',num2str(dum_r),'__Bmat_',upper(B_str),'.xlsx'];
copy=[Dato,'__Case_',upper(case_str),'__Week_',num2str(week),'__FlexW_',upper(flexW_str),'__FlexT_SP_',upper(flexSP_TELB_str),'__FlexT_SO_',upper(flexSO_TELB_str),'__Rent_',upper(rent_str),'__Dummy_',num2str(dum_r),'__Bmat_',upper(B_str)];
fprintf('\nPrinting to Excel, filename:\n%s\n',copy);

oldpath = path;
path(oldpath,[filstart2 '\Xpressmp\matlab'])
D_NS_T=zeros(39,28); D_SP_T=zeros(39,28); D_SO_T=zeros(39,28);
T_Dem_NS=zeros(39,28);T_Dem_SP=zeros(39,28);T_Dem_SO=zeros(39,28);
if info_case==1;
    nRoutes_TDay=zeros(1,7);
    Routes_TDay=cell(1,7);
    for d=1:7
        fprintf('\nRunning Transport Daily (from DD) for day %d\nMax computational time: %d\n',d,maxtime_T);
        TimeX=Time_Base(Time_Base>=((d-1)*4+1)&Time_Base<=((d-1)*4+4));
        
        disp('Creating routes for transport model');
        %Finding the routes available
        RoutesAvailable=find(RouteUsedDay_W(:,d)>0);
        [nRoutes_T, Routes_T, B_matrix_T, A_ir_T, RouteCost_Internal, RouteCost_External, ReturnTime_T]=transporter_routes(nRoutes_W,RoutesAvailable,nr_ark,B_matrix,A_ir,OrgCost_Int,OrgCost_Ext,OrgReturnTime,dep_routes,dum_r,samecost);
        nRoutes_TDay(d)=nRoutes_T; 
        Routes_TDay{d}=Routes_T;
        
        
        
        
        if dep_demand==0
            D_NS_T(:,TimeX)=OrgD_NS(:,TimeX);D_SP_T(:,TimeX)=OrgD_SP(:,TimeX);D_SO_T(:,TimeX)=OrgD_SO(:,TimeX);
        else
            %summerer rutene til  bli demanden p tid for hver kunde
            D1=sum(yNS_W{d},2);
            D2=sum(ySO_W{d},2);
            D3=sum(ySP_W{d},2);
            D_NS_T=reshape(D1,[size(D1,1),size(D1,3)]);
            D_SO_T=reshape(D2,[size(D2,1),size(D2,3)]);
            D_SP_T=reshape(D3,[size(D3,1),size(D3,3)]);
            T_Dem_NS=T_Dem_NS+D_NS_T;
            T_Dem_SP=T_Dem_SP+D_SP_T;
            T_Dem_SO=T_Dem_SO+D_SO_T;
        end
        tic;
        moselexec(Mosel_T);
        t_T(d)=toc;
        obj_T(d)=objval_T;
        optimal_T(d)=optsol_T;
        Pallets_T{d}=Pallets_rt_T;
        SumPall_T(d)=SumP_T;
        %RouteUsed_T=[RouteUsed_T RouteUsed_T_mos];
        ySP_T{d}=ySP_T_mos;
        ySO_T{d}=ySO_T_mos;
        yNS_T{d}=yNS_T_mos;
        nbTrucksPer{d}=NbT;
        nbTrucks{d}=NbT;
        gap_T(d)=Tgap;
        Fill_Truck{d}=FT;
        TruckPeriod(:,d)=TS; %Truck in use each period
        TimeServedSO_T{d}=SO_Time_T;
        if optimal_T(d)==1
            fprintf('The solution is optimal and has the value: %4.2f\nTime used %4.2f\n',obj_T(d),t_T(d));
        else
            fprintf('Not sure if optimal solution with value: %4.2f\nTime used %4.2f\n',obj_T(d),t_T(d));
        end
    end
    RouteUsed_T=unique(RouteUsed_T(RouteUsed_T>0));
    tot_dd=sum(obj_T);
    fprintf('\n\nTotal cost for the week for the wholesaler model in Daily-Daily information case: %4.2f\n',tot_dd);
elseif info_case==2
    nRoutes_TDay=zeros(1,7);
    Routes_TDay=cell(1,7);
    %Summerer over rutene og s lager dagvis demand
    %NS=sum(yNS_W,2);SO=sum(ySO_W,2);SP=sum(ySP_W,2);
    D1=sum(yNS_W,2);
    D2=sum(ySO_W,2);
    D3=sum(ySP_W,2);
    NS=reshape(D1,[size(D1,1),size(D1,3)]);
    SO=reshape(D2,[size(D2,1),size(D2,3)]);
    SP=reshape(D3,[size(D3,1),size(D3,3)]);
    T_Dem_NS=NS;
    T_Dem_SP=SP;
    T_Dem_SO=SO;
    for d=1:7
        fprintf('\nRunning Transporter Daily (from WD) for day %d\nMax computational time: %d\n',d,maxtime_T);
        TimeX=Time_Base(Time_Base>=((d-1)*4+1)&Time_Base<=((d-1)*4+4));
        if dep_demand==0
            D_NS_T(:,TimeX)=OrgD_NS(:,TimeX);D_SP_T(:,TimeX)=OrgD_SP(:,TimeX);D_SO_T(:,TimeX)=OrgD_SO(:,TimeX);
        else
            D_NS_T(:,TimeX)=NS(:,TimeX);D_SP_T(:,TimeX)=SP(:,TimeX);D_SO_T(:,TimeX)=SO(:,TimeX);
        end

        disp('Creating routes for the transporter model');
        %Finding the routes available
        RoutesAvailable=find(RouteUsedDay_W(:,d)>0);
        [nRoutes_T, Routes_T, B_matrix_T, A_ir_T, RouteCost_Internal, RouteCost_External, ReturnTime_T]=transporter_routes(nRoutes_W,RoutesAvailable,nr_ark,B_matrix,A_ir,OrgCost_Int,OrgCost_Ext,OrgReturnTime,dep_routes,dum_r,samecost);
        nRoutes_TDay(d)=nRoutes_T; 
        Routes_TDay{d}=Routes_T;

        tic;
        moselexec(Mosel_T);
        t_T(d)=toc;
        obj_T(d)=objval_T;
        optimal_T(d)=optsol_T;
        Pallets_T{d}=Pallets_rt_T;
        SumPall_T(d)=SumP_T;
        %RouteUsed_T=[RouteUsed_T RouteUsed_T_mos];
        ySP_T{d}=ySP_T_mos;
        ySO_T{d}=ySO_T_mos;
        yNS_T{d}=yNS_T_mos;
        nbTrucksPer{d}=NbT;
        nbTrucks{d}=NbT;
        gap_T(d)=Tgap;
        Fill_Truck{d}=FT;
        TruckPeriod(:,d)=TS; %Truck in use each period
        TimeServedSO_T{d}=SO_Time_T;
        if optimal_T(d)==1
            fprintf('The solution is optimal and has value: %4.2f\nTime used %4.2f\n',obj_T(d),t_T(d));
        else
            fprintf('Not sure if optimal solution with value: %4.2f\nTime used %4.2f\n',obj_T(d),t_T(d));
        end
    end
    RouteUsed_T=unique(RouteUsed_T(RouteUsed_T>0));
    tot_dd=sum(obj_T);
    fprintf('\n\nTotal cost for the week for wholesaler in Weekly-Daily information case: %4.2f\n',tot_dd);
elseif info_case==3
    if dep_demand==0
        D_NS_T=OrgD_NS; D_SP_T=OrgD_SP; D_SO_T=OrgD_SO;
    else
        D1=sum(yNS_W,2);
        D2=sum(ySO_W,2);
        D3=sum(ySP_W,2);
        D_NS_T=reshape(D1,[size(D1,1),size(D1,3)]);
        D_SO_T=reshape(D2,[size(D2,1),size(D2,3)]);
        D_SP_T=reshape(D3,[size(D3,1),size(D3,3)]);
        T_Dem_NS=D_NS_T;
        T_Dem_SP=D_SP_T;
        T_Dem_SO=D_SO_T;
    end
    TimeX=Time_Base;
    fprintf('\nRunning Transport Weekly (From WW)\nMax computational time: %d\n',maxtime_T);

        disp('Creating routes for transport model');
        %Finding the routes available
        RoutesAvailable=find(sum(RouteUsedDay_W,2)>0);
        [nRoutes_T, Routes_T, B_matrix_T, A_ir_T, RouteCost_Internal, RouteCost_External, ReturnTime_T]=transporter_routes(nRoutes_W,RoutesAvailable,nr_ark,B_matrix,A_ir,OrgCost_Int,OrgCost_Ext,OrgReturnTime,dep_routes,dum_r,samecost);
        
    nRoutes_TDay=nRoutes_T;

    disp(datetime('now'));
    tic;
    moselexec(Mosel_T);
    t_T=toc;
    fprintf('\nDone Running in mosel\n');
    obj_T=objval_T;
    optimal_T=optsol_T;
    Pallets=Pallets_rt_T;
    SumPall_W=SumP_T;
    ySP_T=ySP_T_mos;
    ySO_T=ySO_T_mos;
    yNS_T=yNS_T_mos;
    nbTrucks=[];
    nbTrucks=NbT;
    gap_T=Tgap;
    Fill_Truck=FT;
    TruckPeriod=TS; %Truck in use each period
    TimeServedSO_T=SO_Time_T;
    if optimal_T==1
        fprintf('The solution is optimal and has the value: %4.2f\nTime used %4.2f\n',obj_T,t_T);
    else
        fprintf('Not sure if optimal solution with value: %4.2f\nTime used %4.2f\n',obj_T,t_T);
    end
else
    disp('Error information case and transporter model');
end
path(oldpath)

RouteUsed_T=unique(RouteUsed_T(RouteUsed_T>0));

disp('Finito <3');



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%% CREATING OUTPUT %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if info_case==3
    disp('Creating .txt file');
    fileID = fopen(filPrint,'wt');
    fprintf(fileID,'!Data input til xpress\n');
    fprintf(fileID,'\n');
    fprintf(fileID,'nCustomers:     %d\n', nCustomers);
    fprintf(fileID,'\n');
    fprintf(fileID,'nRoutes_T:	%d\n', nRoutes_T);
    fprintf(fileID,'\n');
    fprintf(fileID,'nOwned:	%d\n', nOwned);
    fprintf(fileID,'\n');
    fprintf(fileID,'maxTrucks:	%d\n', maxTrucks);
    fprintf(fileID,'\n');
    fprintf(fileID,'nTime:	%d\n', nTime);
    fprintf(fileID,'\n');
    fprintf(fileID,'maxtime_T:	%d\n', maxtime_T);
    fprintf(fileID,'\n');
    fprintf(fileID,'lagSP_Early:	%d\n', lagSP_Early);
    fprintf(fileID,'\n');
    fprintf(fileID,'lagSP_Late:	%d\n', lagSP_Late);
    fprintf(fileID,'\n');
    fprintf(fileID,'lagSO_Late:	%d\n', lagSO_Late);
    fprintf(fileID,'\n');
    fprintf(fileID,'lagSO_Early:	%d\n', lagSO_Early);
    fprintf(fileID,'\n');
    fprintf(fileID,'alpha_SP:	%d\n', alpha_SP);
    fprintf(fileID,'\n');
    fprintf(fileID,'alpha_SO:	%d\n', alpha_SO);
    fprintf(fileID,'\n');
    fprintf(fileID,'TruckCapacity:	%d\n', TruckCapacity);
    fprintf(fileID,'\n');
    fprintf(fileID,'TruckCost_Int:	%d\n', TruckCost_Int);
    fprintf(fileID,'\n');
    fprintf(fileID,'TruckCost_Ext:	%d\n', TruckCost_Ext);
    fprintf(fileID,'\n');
    fprintf(fileID,'B_str:	%d\n', B_str);
    
    Set_TimeX=sprintf('%d ',TimeX);
    fprintf(fileID,'\nTimeX: [ %s]\n', Set_TimeX);
    
    Set_RouteCost_Internal=sprintf('%d ',RouteCost_Internal);
    fprintf(fileID,'\nRouteCost_Internal: [ %s\n]\n', Set_RouteCost_Internal);
    
    Set_RouteCost_External=sprintf('%d ',RouteCost_External);
    fprintf(fileID,'\nRouteCost_External: [ %s\n]\n', Set_RouteCost_External);
    
    Set_ReturnTime_T=sprintf('%d ',ReturnTime_T);
    fprintf(fileID,'\nReturnTime_T: [ %s\n]\n', Set_ReturnTime_T);
    
    
    fprintf(fileID,'\nB_matrix_T: [');
    for rr=1:nRoutes_T
        Set_B_matrix_T=sprintf('%d ',B_matrix_T(rr,:));
        fprintf(fileID,' %s \n', Set_B_matrix_T);
    end
    fprintf(fileID,'\n]\n');
    
    
    fprintf(fileID,'\nA_ir_T: [');
    for ii=1:nCustomers
        Set_A_ir_T=sprintf('%d ',A_ir_T(ii,:));
        fprintf(fileID,' %s \n', Set_A_ir_T);
    end
    fprintf(fileID,'\n]\n');
    
    fprintf(fileID,'\nD_SP_T: [');
    for ii=1:nCustomers
        Set_D_SP_T=sprintf('%d ',D_SP_T(ii,:));
        fprintf(fileID,' %s \n', Set_D_SP_T);
    end
    fprintf(fileID,'\n]\n');
    
    fprintf(fileID,'\nD_SO_T: [');
    for ii=1:nCustomers
        Set_D_SO_T=sprintf('%d ',D_SO_T(ii,:));
        fprintf(fileID,' %s \n', Set_D_SO_T);
    end
    fprintf(fileID,'\n]\n');
    
    fprintf(fileID,'\nD_NS_T: [');
    for ii=1:nCustomers
        Set_D_NS_T=sprintf('%d ',D_NS_T(ii,:));
        fprintf(fileID,' %s \n', Set_D_NS_T);
    end
    fprintf(fileID,'\n]\n');
    
    fclose(fileID);
    disp('Created .txt file');
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%PrintingWholesaler%%%%%%%%%%%%%%%%%%%%%%
    disp('Creating .txt file');
    fileID = fopen(filPrint2,'wt');
    fprintf(fileID,'!Data input til xpress\n');
    fprintf(fileID,'\n');
    fprintf(fileID,'nCustomers:     %d\n', nCustomers);
    fprintf(fileID,'\n');
    fprintf(fileID,'nRoutes_W:	%d\n', nRoutes_W);
    fprintf(fileID,'\n');
    fprintf(fileID,'nBreakpoints:	%d\n', nBreakpoints);
    fprintf(fileID,'\n');
    fprintf(fileID,'nTime:	%d\n', nTime);
    fprintf(fileID,'\n');

    fprintf(fileID,'maxtime_W:	%d\n', maxtime_W);
    fprintf(fileID,'\n');
    fprintf(fileID,'lag_W:	%d\n', lag_W);
    fprintf(fileID,'\n');
    fprintf(fileID,'alpha_W:	%d\n', alpha_W);
    fprintf(fileID,'\n');
    fprintf(fileID,'Day:	-1\n');
    fprintf(fileID,'\n');
    fprintf(fileID,'AvarageLevel:	%d\n',AvarageLevel);
    fprintf(fileID,'\n');
    
    Set_TimeX=sprintf('%d ',TimeX);
    fprintf(fileID,'\nTimeX: [ %s]\n', Set_TimeX);
    
    Set_RouteCost_Internal=sprintf('%d ',RouteCost_Internal);
    fprintf(fileID,'\nRouteCost_Internal: [ %s\n]\n', Set_RouteCost_Internal);
    
    Set_LevelingCost=sprintf('%d ',LevelingCost);
    fprintf(fileID,'\nLevelingCost: [ %s\n]\n', Set_LevelingCost);
    
    Set_InventoryCap=sprintf('%d ',InventoryCap);
    fprintf(fileID,'\nInventoryCap: [ %s\n]\n', Set_InventoryCap);
    
    Set_Beta=sprintf('%d ',Beta);
    fprintf(fileID,'\nBeta: [ %s\n]\n', Set_Beta);
    
    Set_TimeDay=sprintf('%d ',TimeDay');
    fprintf(fileID,'\nTimeDay: [ %s\n]\n', Set_TimeDay);
    
    Set_Cost_Pallet=sprintf('%d ',Cost_Pallet);
    fprintf(fileID,'\nCost_Pallet: [ %s\n]\n', Set_Cost_Pallet);
    

    
    fprintf(fileID,'\nB_matrix: [');
    for rr=1:nRoutes_W
        Set_B_matrix=sprintf('%d ',B_matrix(rr,:));
        fprintf(fileID,' %s \n', Set_B_matrix);
    end
    fprintf(fileID,'\n]\n');
    
    
    fprintf(fileID,'\nA_ir: [');
    for ii=1:nCustomers
        Set_A_ir=sprintf('%d ',A_ir(ii,:));
        fprintf(fileID,' %s \n', Set_A_ir);
    end
    fprintf(fileID,'\n]\n');
    
    fprintf(fileID,'\nD_SP: [');
    for ii=1:nCustomers
        Set_D_SP=sprintf('%d ',D_SP(ii,:));
        fprintf(fileID,' %s \n', Set_D_SP);
    end
    fprintf(fileID,'\n]\n');
    
    fprintf(fileID,'\nD_SO: [');
    for ii=1:nCustomers
        Set_D_SO=sprintf('%d ',D_SO(ii,:));
        fprintf(fileID,' %s \n', Set_D_SO);
    end
    fprintf(fileID,'\n]\n');
    
    fprintf(fileID,'\nD_NS: [');
    for ii=1:nCustomers
        Set_D_NS=sprintf('%d ',D_NS(ii,:));
        fprintf(fileID,' %s \n', Set_D_NS);
    end
    fprintf(fileID,'\n]\n');
    
    fprintf(fileID,'\nLastInventory: [');
    for ii=1:nCustomers
        Set_LastInventory=sprintf('%d ',LastInventory(ii,:));
        fprintf(fileID,' %s \n', Set_LastInventory);
    end
    fprintf(fileID,'\n]\n');
    
    fclose(fileID);
    disp('Created .txt file');    
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

disp('Printing out output');

%Served
disp('Printing out Served Pallets');
outMatServe=cell(1, 6);
radServe=1;

for day=1:7
    for p=1:4
        periode=(day-1)*4+p;
        if info_case==1;
            %WHOLESALER
            
            %W_NS
            W_NSi=[]; W_NSr=[];
            [W_NSi, W_NSr]=find(reshape(yNS_W{1,day}(:,:,periode),[nCustomers,nRoutes_W])>0.1);
            for k=1:size(W_NSi,1)
                W_yNS=yNS_W{1,day}(W_NSi(k), W_NSr(k), periode);
                outMatServe{radServe,1}='Wholesaler';
                outMatServe{radServe,2}='NS';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=W_yNS;
                outMatServe{radServe,5}=W_NSi(k);
                outMatServe{radServe,6}=W_NSr(k);
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
            %W_SP
            W_SPi=[]; W_SPr=[];
            [W_SPi, W_SPr]=find(reshape(ySP_W{1,day}(:,:,periode),[nCustomers,nRoutes_W])>0.1);
            for k=1:size(W_SPi,1)
                W_ySP=ySP_W{1,day}(W_SPi(k), W_SPr(k), periode);
                outMatServe{radServe,1}='Wholesaler';
                outMatServe{radServe,2}='SP';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=W_ySP;
                outMatServe{radServe,5}=W_SPi(k);
                outMatServe{radServe,6}=W_SPr(k);
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
            %W_SO
            W_SOi=[]; W_SOr=[];
            [W_SOi, W_SOr]=find(reshape(ySO_W{1,day}(:,:,periode),[nCustomers,nRoutes_W])>0.1);
            for k=1:size(W_SOi,1)
                W_ySO=ySO_W{1,day}(W_SOi(k), W_SOr(k), periode);
                outMatServe{radServe,1}='Wholesaler';
                outMatServe{radServe,2}='SO';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=W_ySO;
                outMatServe{radServe,5}=W_SOi(k);
                outMatServe{radServe,6}=W_SOr(k);
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
            %TRANSPORT
            %T_NS
            T_NSi=[]; T_NSr=[];
            [T_NSi, T_NSr]=find(reshape(yNS_T{1,day}(:,:,periode),[nCustomers,nRoutes_TDay(day)])>0.1);
            for k=1:size(T_NSi,1)
                T_yNS=yNS_T{1,day}(T_NSi(k), T_NSr(k), periode);
                outMatServe{radServe,1}='Transport';
                outMatServe{radServe,2}='NS';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=T_yNS;
                outMatServe{radServe,5}=T_NSi(k);
                outMatServe{radServe,6}=Routes_TDay{day}(T_NSr(k));
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
            %T_SP
            T_SPi=[]; T_SPr=[];
            [T_SPi, T_SPr]=find(reshape(ySP_T{1,day}(:,:,periode),[nCustomers,nRoutes_TDay(day)])>0.1);
            for k=1:size(T_SPi,1)
                T_ySP=ySP_T{1,day}(T_SPi(k), T_SPr(k), periode);
                outMatServe{radServe,1}='Transport';
                outMatServe{radServe,2}='SP';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=T_ySP;
                outMatServe{radServe,5}=T_SPi(k);
                outMatServe{radServe,6}=Routes_TDay{day}(T_SPr(k));
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
            %T_SO
            T_SOi=[]; T_SOr=[];
            [T_SOi, T_SOr]=find(reshape(ySO_T{1,day}(:,:,periode),[nCustomers,nRoutes_TDay(day)])>0.1);
            for k=1:size(T_SOi,1)
                T_ySO=ySO_T{1,day}(T_SOi(k), T_SOr(k), periode);
                outMatServe{radServe,1}='Transport';
                outMatServe{radServe,2}='SO';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=T_ySO;
                outMatServe{radServe,5}=T_SOi(k);
                outMatServe{radServe,6}=Routes_TDay{day}(T_SOr(k));
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
        else
            
            %WHOLESALER
            
            %W_NS
            W_NSi=[]; W_NSr=[];
            [W_NSi, W_NSr]=find(reshape(yNS_W(:,:,periode),[nCustomers,nRoutes_W])>0.1);
            for k=1:size(W_NSi,1)
                W_yNS=yNS_W(W_NSi(k), W_NSr(k), periode);
                outMatServe{radServe,1}='Wholesaler';
                outMatServe{radServe,2}='NS';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=W_yNS;
                outMatServe{radServe,5}=W_NSi(k);
                outMatServe{radServe,6}=W_NSr(k);
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
            %W_SP
            W_SPi=[]; W_SPr=[];
            [W_SPi, W_SPr]=find(reshape(ySP_W(:,:,periode),[nCustomers,nRoutes_W])>0.1);
            for k=1:size(W_SPi,1)
                W_ySP=ySP_W(W_SPi(k), W_SPr(k), periode);
                outMatServe{radServe,1}='Wholesaler';
                outMatServe{radServe,2}='SP';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=W_ySP;
                outMatServe{radServe,5}=W_SPi(k);
                outMatServe{radServe,6}=W_SPr(k);
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
            %W_SO
            W_SOi=[]; W_SOr=[];
            [W_SOi, W_SOr]=find(reshape(ySO_W(:,:,periode),[nCustomers,nRoutes_W])>0.1);
            for k=1:size(W_SOi,1)
                W_ySO=ySO_W(W_SOi(k), W_SOr(k), periode);
                outMatServe{radServe,1}='Wholesaler';
                outMatServe{radServe,2}='SO';
                outMatServe{radServe,3}=day;
                outMatServe{radServe,4}=W_ySO;
                outMatServe{radServe,5}=W_SOi(k);
                outMatServe{radServe,6}=W_SOr(k);
                outMatServe{radServe,7}=periode;
                radServe=radServe+1;
            end
            
            %TRANSPORT
            if info_case==2
                %T_NS
                T_NSi=[]; T_NSr=[];
                [T_NSi, T_NSr]=find(reshape(yNS_T{1,day}(:,:,periode),[nCustomers,nRoutes_TDay(day)])>0.1);
                for k=1:size(T_NSi,1)
                    T_yNS=yNS_T{1,day}(T_NSi(k), T_NSr(k), periode);
                    outMatServe{radServe,1}='Transport';
                    outMatServe{radServe,2}='NS';
                    outMatServe{radServe,3}=day;
                    outMatServe{radServe,4}=T_yNS;
                    outMatServe{radServe,5}=T_NSi(k);
                    outMatServe{radServe,6}=Routes_TDay{day}(T_NSr(k));
                    outMatServe{radServe,7}=periode;
                    radServe=radServe+1;
                end
                %T_SP
                T_SPi=[]; T_SPr=[];
                [T_SPi, T_SPr]=find(reshape(ySP_T{1,day}(:,:,periode),[nCustomers,nRoutes_TDay(day)])>0.1);
                for k=1:size(T_SPi,1)
                    T_ySP=ySP_T{1,day}(T_SPi(k), T_SPr(k), periode);
                    outMatServe{radServe,1}='Transport';
                    outMatServe{radServe,2}='SP';
                    outMatServe{radServe,3}=day;
                    outMatServe{radServe,4}=T_ySP;
                    outMatServe{radServe,5}=T_SPi(k);
                    outMatServe{radServe,6}=Routes_TDay{day}(T_SPr(k));
                    outMatServe{radServe,7}=periode;
                    radServe=radServe+1;
                end
                %T_SO
                T_SOi=[]; T_SOr=[];
                [T_SOi, T_SOr]=find(reshape(ySO_T{1,day}(:,:,periode),[nCustomers,nRoutes_TDay(day)])>0.1);
                for k=1:size(T_SOi,1)
                    T_ySO=ySO_T{1,day}(T_SOi(k), T_SOr(k), periode);
                    outMatServe{radServe,1}='Transport';
                    outMatServe{radServe,2}='SO';
                    outMatServe{radServe,3}=day;
                    outMatServe{radServe,4}=T_ySO;
                    outMatServe{radServe,5}=T_SOi(k);
                    outMatServe{radServe,6}=Routes_TDay{day}(T_SOr(k));
                    outMatServe{radServe,7}=periode;
                    radServe=radServe+1;
                end
                
                
            elseif info_case==3
                %T_NS
                T_NSi=[]; T_NSr=[];
                [T_NSi, T_NSr]=find(reshape(yNS_T(:,:,periode),[nCustomers,nRoutes_T])>0.1);
                for k=1:size(T_NSi,1)
                    T_yNS=yNS_T(T_NSi(k), T_NSr(k), periode);
                    outMatServe{radServe,1}='Transport';
                    outMatServe{radServe,2}='NS';
                    outMatServe{radServe,3}=day;
                    outMatServe{radServe,4}=T_yNS;
                    outMatServe{radServe,5}=T_NSi(k);
                    outMatServe{radServe,6}=Routes_T(T_NSr(k));
                    outMatServe{radServe,7}=periode;
                    radServe=radServe+1;
                end
                %T_SP
                T_SPi=[]; T_SPr=[];
                [T_SPi, T_SPr]=find(reshape(ySP_T(:,:,periode),[nCustomers,nRoutes_T])>0.1);
                for k=1:size(T_SPi,1)
                    T_ySP=ySP_T(T_SPi(k), T_SPr(k), periode);
                    outMatServe{radServe,1}='Transport';
                    outMatServe{radServe,2}='SP';
                    outMatServe{radServe,3}=day;
                    outMatServe{radServe,4}=T_ySP;
                    outMatServe{radServe,5}=T_SPi(k);
                    outMatServe{radServe,6}=Routes_T(T_SPr(k));
                    outMatServe{radServe,7}=periode;
                    radServe=radServe+1;
                end
                %T_SO
                T_SOi=[]; T_SOr=[];
                [T_SOi, T_SOr]=find(reshape(ySO_T(:,:,periode),[nCustomers,nRoutes_T])>0.1);
                for k=1:size(T_SOi,1)
                    T_ySO=ySO_T(T_SOi(k), T_SOr(k), periode);
                    outMatServe{radServe,1}='Transport';
                    outMatServe{radServe,2}='SO';
                    outMatServe{radServe,3}=day;
                    outMatServe{radServe,4}=T_ySO;
                    outMatServe{radServe,5}=T_SOi(k);
                    outMatServe{radServe,6}=Routes_T(T_SOr(k));
                    outMatServe{radServe,7}=periode;
                    radServe=radServe+1;
                end
            end
        end
    end
end


%DEMAND
disp('Printing out demand');
outMatDemand=cell(1,5);
radDemand=1;

%WHOLESALER
%SO
[W_Dem_SOi, W_Dem_SOt]=find(OrgD_SO>0);
for k=1:size(W_Dem_SOi,1)
    W_D_SO=OrgD_SO(W_Dem_SOi(k),W_Dem_SOt(k));
    outMatDemand{radDemand,1}='Wholesaler';
    outMatDemand{radDemand,2}='SO';
    outMatDemand{radDemand,3}=W_D_SO;
    outMatDemand{radDemand,4}=W_Dem_SOi(k);
    outMatDemand{radDemand,5}=W_Dem_SOt(k);
    radDemand=radDemand+1;
end
%SP
[W_Dem_SPi, W_Dem_SPt]=find(OrgD_SP>0);
for k=1:size(W_Dem_SPi,1)
    W_D_SP=OrgD_SP(W_Dem_SPi(k),W_Dem_SPt(k));
    outMatDemand{radDemand,1}='Wholesaler';
    outMatDemand{radDemand,2}='SP';
    outMatDemand{radDemand,3}=W_D_SP;
    outMatDemand{radDemand,4}=W_Dem_SPi(k);
    outMatDemand{radDemand,5}=W_Dem_SPt(k);
    radDemand=radDemand+1;
end
%NS
[W_Dem_NSi, W_Dem_NSt]=find(OrgD_NS>0);
for k=1:size(W_Dem_NSi,1)
    W_D_NS=OrgD_NS(W_Dem_NSi(k),W_Dem_NSt(k));
    outMatDemand{radDemand,1}='Wholesaler';
    outMatDemand{radDemand,2}='NS';
    outMatDemand{radDemand,3}=W_D_NS;
    outMatDemand{radDemand,4}=W_Dem_NSi(k);
    outMatDemand{radDemand,5}=W_Dem_NSt(k);
    radDemand=radDemand+1;
end

%TRANSPORT
%SO
[T_Dem_SOi, T_Dem_SOt]=find(T_Dem_SO>0);
for k=1:size(T_Dem_SOi,1)
    T_D_SO=T_Dem_SO(T_Dem_SOi(k),T_Dem_SOt(k));
    outMatDemand{radDemand,1}='Transport';
    outMatDemand{radDemand,2}='SO';
    outMatDemand{radDemand,3}=T_D_SO;
    outMatDemand{radDemand,4}=T_Dem_SOi(k);
    outMatDemand{radDemand,5}=T_Dem_SOt(k);
    radDemand=radDemand+1;
end
%SP
[T_Dem_SPi, T_Dem_SPt]=find(T_Dem_SP>0);
for k=1:size(T_Dem_SPi,1)
    T_D_SP=T_Dem_SP(T_Dem_SPi(k),T_Dem_SPt(k));
    outMatDemand{radDemand,1}='Transport';
    outMatDemand{radDemand,2}='SP';
    outMatDemand{radDemand,3}=T_D_SP;
    outMatDemand{radDemand,4}=T_Dem_SPi(k);
    outMatDemand{radDemand,5}=T_Dem_SPt(k);
    radDemand=radDemand+1;
end
%NS
[T_Dem_NSi, T_Dem_NSt]=find(T_Dem_NS>0);
for k=1:size(T_Dem_NSi,1)
    T_D_NS=T_Dem_NS(T_Dem_NSi(k),T_Dem_NSt(k));
    outMatDemand{radDemand,1}='Transport';
    outMatDemand{radDemand,2}='NS';
    outMatDemand{radDemand,3}=T_D_NS;
    outMatDemand{radDemand,4}=T_Dem_NSi(k);
    outMatDemand{radDemand,5}=T_Dem_NSt(k);
    radDemand=radDemand+1;
end

%Time Served
disp('Printing out time served');
outMatTimeServed=cell(1,7);
radTimeServed=1;
d=[];
day=[];

for c=1:39
    if info_case==2||info_case==3
        %WHOLESALER
        %SP
        [W_Move_SPp, W_Move_SPt]=find(reshape(TimeServedSP_W(c,:,:),[28,28])>0.1);
        for k=1:size(W_Move_SPp,1)
            W_Move_SP=TimeServedSP_W(c,W_Move_SPp(k),W_Move_SPt(k));
            outMatTimeServed{radTimeServed,1}='Wholesaler';
            outMatTimeServed{radTimeServed,2}='SP';
            if W_Move_SPp(k)~=W_Move_SPt(k)
                outMatTimeServed{radTimeServed,3}='Moved';
            else
                outMatTimeServed{radTimeServed,3}='Not Moved';
            end
            outMatTimeServed{radTimeServed,4}=W_Move_SP;
            outMatTimeServed{radTimeServed,5}=c;
            outMatTimeServed{radTimeServed,6}=W_Move_SPp(k);
            outMatTimeServed{radTimeServed,7}=W_Move_SPt(k);
            radTimeServed=radTimeServed+1;
        end
        if info_case==3
            %TRANSPORT info case 3
            
            %SO
            [T_Move_SOp, T_Move_SOt]=find(reshape(TimeServedSO_T(c,:,:),[28,28])>0.1);
            for k=1:size(T_Move_SOp,1)
                T_Move_SO=TimeServedSO_T(c,T_Move_SOp(k),T_Move_SOt(k));
                outMatTimeServed{radTimeServed,1}='Transport';
                outMatTimeServed{radTimeServed,2}='SO';
                if T_Move_SOp(k)~=T_Move_SOt(k)
                    outMatTimeServed{radTimeServed,3}='Moved';
                else
                    outMatTimeServed{radTimeServed,3}='Not Moved';
                end
                outMatTimeServed{radTimeServed,4}=T_Move_SO;
                outMatTimeServed{radTimeServed,5}=c;
                outMatTimeServed{radTimeServed,6}=T_Move_SOp(k);
                outMatTimeServed{radTimeServed,7}=T_Move_SOt(k);
                radTimeServed=radTimeServed+1;
            end
        else
            
            for day=1:7
                %TRANSPORT Info case 2
                
                %SO
                [T_Move_SOp, T_Move_SOt]=find(reshape(TimeServedSO_T{1,day}(c,:,:),[28,28])>0.1);
                for k=1:size(T_Move_SOp,1)
                    T_Move_SO=TimeServedSO_T{1,day}(c,T_Move_SOp(k),T_Move_SOt(k));
                    outMatTimeServed{radTimeServed,1}='Transport';
                    outMatTimeServed{radTimeServed,2}='SO';
                    if T_Move_SOp(k)~=T_Move_SOt(k)
                        outMatTimeServed{radTimeServed,3}='Moved';
                    else
                        outMatTimeServed{radTimeServed,3}='Not Moved';
                    end
                    outMatTimeServed{radTimeServed,4}=T_Move_SO;
                    outMatTimeServed{radTimeServed,5}=c;
                    outMatTimeServed{radTimeServed,6}=T_Move_SOp(k);
                    outMatTimeServed{radTimeServed,7}=T_Move_SOt(k);
                    radTimeServed=radTimeServed+1;
                end
            end
        end
    else
        
        %Infocase 1:
        for day=1:7
            %WHOLESALER          %SP
            [W_Move_SPp, W_Move_SPt]=find(reshape(TimeServedSP_W{1,day}(c,:,:),[28,28])>0.1);
            for k=1:size(W_Move_SPp,1)
                W_Move_SP=TimeServedSP_W{1,day}(c,W_Move_SPp(k),W_Move_SPt(k));
                outMatTimeServed{radTimeServed,1}='Wholesaler';
                outMatTimeServed{radTimeServed,2}='SP';
                if W_Move_SPp(k)~=W_Move_SPt(k)
                    outMatTimeServed{radTimeServed,3}='Moved';
                else
                    outMatTimeServed{radTimeServed,3}='Not Moved';
                end
                outMatTimeServed{radTimeServed,4}=W_Move_SP;
                outMatTimeServed{radTimeServed,5}=c;
                outMatTimeServed{radTimeServed,6}=W_Move_SPp(k);
                outMatTimeServed{radTimeServed,7}=W_Move_SPt(k);
                radTimeServed=radTimeServed+1;
            end
            
            %TRANSPORT
            
            %SO
            [T_Move_SOp, T_Move_SOt]=find(reshape(TimeServedSO_T{1,day}(c,:,:),[28,28])>0.1);
            for k=1:size(T_Move_SOp,1)
                T_Move_SO=TimeServedSO_T{1,day}(c,T_Move_SOp(k),T_Move_SOt(k));
                outMatTimeServed{radTimeServed,1}='Transport';
                outMatTimeServed{radTimeServed,2}='SO';
                if T_Move_SOp(k)~=T_Move_SOt(k)
                    outMatTimeServed{radTimeServed,3}='Moved';
                else
                    outMatTimeServed{radTimeServed,3}='Not Moved';
                end
                outMatTimeServed{radTimeServed,4}=T_Move_SO;
                outMatTimeServed{radTimeServed,5}=c;
                outMatTimeServed{radTimeServed,6}=T_Move_SOp(k);
                outMatTimeServed{radTimeServed,7}=T_Move_SOt(k);
                radTimeServed=radTimeServed+1;
            end
        end
        
    end
end



%Trucks
disp('Printing out Trucks');
outMatTruck=cell(1,4);
radTruck=1;

for b=1:maxTrucks
    if info_case==3
        [nbTr, nbTt]=find(reshape(nbTrucks(:,:,b),[nRoutes_T,28])>0.1);
        for k=1:size(nbTr,1)
            nbT=nbTrucks(nbTr(k),nbTt(k),b);
            outMatTruck{radTruck,1}=Routes_T(nbTr(k));
            outMatTruck{radTruck,2}=nbTt(k);
            outMatTruck{radTruck,3}=b;
            outMatTruck{radTruck,4}=nbT;
            outMatTruck{radTruck,5}='Weekly';
            outMatTruck{radTruck,6}=Fill_Truck(nbTt(k),b);
            radTruck=radTruck+1;
        end
    else
        for day=1:7
            [nbTr, nbTt]=find(reshape(nbTrucks{1,day}(:,:,b),[nRoutes_TDay(day),28])>0.1);
            if isempty(nbTr)==0;
            for k=1:size(nbTr,1)
                nbT=nbTrucks{1,day}(nbTr(k),nbTt(k),b);
                outMatTruck{radTruck,1}=Routes_TDay{day}(nbTr(k));
                outMatTruck{radTruck,2}=nbTt(k);
                outMatTruck{radTruck,3}=b;
                outMatTruck{radTruck,4}=nbT;
                outMatTruck{radTruck,5}=day;
                outMatTruck{radTruck,6}=Fill_Truck{1,day}(nbTt(k),b);
                radTruck=radTruck+1;
            end
            end
        end
    end
end

disp('Printing out Truck in Use');
outMatUse=num2cell(TruckPeriod);

disp('Printing out Parameters');

if nOwned==0
    nO=maxTrucks;
else
    nO=nOwned;
end
if alpha_W==0
    lag_W2=0;
else
    lag_W2=lag_W;
end

outMatParameters=cell(26,2);
outMatParameters={
    'Retailers',nCustomers;
    'Number Main Routes',nRoutes_W;
    'Number of time Periods',nTime;
    'Cost of Pallets',Cost_Pallet;
    'Average Daily Delivery',AvarageLevel;
    'Leveling Cost',LevelingCost;
    'Cost of Moving',MoveCost;
    'Max Computational Time Wholesaler',maxtime_W;
    'Max Computational Time Transport',maxtime_T;
    'Truck Capacity',TruckCapacity;
    'Truck Cost Own',TruckCost_Int;
    'Truck Cost Rented',TruckCost_Ext;
    'Demand Week',week;
    'Info_Case', info_case;
    'Alpha Wholesaler',alpha_W
    'Time Lag Wholesaler',lag_W2;
    'Alpha SP Transport',alpha_SP;
    'Lag SP Transport', max(lagSP_Early,lagSP_Late);
    'Alpha SO Transport',alpha_SO;
    'Lag SO Transport',max(lagSO_Early,lagSO_Late);
    'MaxTrucks',maxTrucks;
    'Max Owned',nO;
    'Max Rented',(maxTrucks-nO);
    };



disp('Printing out Summary');
outMatSummary=cell(28,5);
radS=1;
if info_case==2||info_case==3
    outMatSummary{radS,1}='Wholesaler';
    outMatSummary{radS,2}=optimal_W;
    outMatSummary{radS,3}=obj_W;
    outMatSummary{radS,4}=t_W;
    outMatSummary{radS,5}='All';
    outMatSummary{radS,6}=gap_W;
    radS=radS+1;
    if info_case==3
        outMatSummary{radS,1}='Transport';
        outMatSummary{radS,2}=optimal_T;
        outMatSummary{radS,3}=obj_T;
        outMatSummary{radS,4}=t_T;
        outMatSummary{radS,5}='All';
        outMatSummary{radS,6}=gap_T;
        radS=radS+1;
    else
        for d=1:7
            outMatSummary{radS,1}='Transport';
            outMatSummary{radS,2}=optimal_T(d);
            outMatSummary{radS,3}=obj_T(d);
            outMatSummary{radS,4}=t_T(d);
            outMatSummary{radS,5}=d;
            outMatSummary{radS,6}=gap_T(d);
            radS=radS+1;
        end
    end
else
    for d=1:7
        outMatSummary{radS,1}='Wholesaler';
        outMatSummary{radS,2}=optimal_W(d);
        outMatSummary{radS,3}=obj_W(d);
        outMatSummary{radS,4}=t_W(d);
        outMatSummary{radS,6}=gap_W(d);
        outMatSummary{radS,5}=d;
        radS=radS+1;
        
        outMatSummary{radS,1}='Transport';
        outMatSummary{radS,2}=optimal_T(d);
        outMatSummary{radS,3}=obj_T(d);
        outMatSummary{radS,4}=t_T(d);
        outMatSummary{radS,6}=gap_T(d);
        outMatSummary{radS,5}=d;
        radS=radS+1;
    end
end



    

%Pallets


xlRange='A2:ZZ3000';


fprintf('\n\nPrinting to Excel, filename:\n\n%s\n',copy);
prompt = '\nCopy before printing for right template. Press any button to continue: ';
random_str = input(prompt,'s');

letter_str={'A' 'B' 'C' 'D' 'E' 'F' 'G' 'H' 'I' 'J' 'K' 'L' 'M' 'N' 'O' 'P' 'Q' 'R' 'S' 'T' 'U' 'V' 'W' 'X' 'Y' 'Z' 'AA' 'BB' 'CC' 'DD' 'EE' 'FF' 'GG' 'HH' 'II' 'JJ' 'KK' 'LL' 'MM' 'NN' 'OO' 'PP' 'QQ' 'RR' 'SS' 'TT' 'UU' 'VV' 'WW' 'XX' 'YY' 'ZZ'};
xlRange1=['A2:',letter_str{1,size(outMatTruck,2)},num2str(size(outMatTruck,1)+1)];
if info_case==3
    xlRange2=['I2:',letter_str{1,size(outMatUse,2)+7+1},num2str(size(outMatUse,1)+1)];
else
    xlRange2=['B2:',letter_str{1,size(outMatUse,2)+1},num2str(size(outMatUse,1)+1)];
end
xlRange3=['A2:',letter_str{1,size(outMatTimeServed,2)},num2str(size(outMatTimeServed,1)+1)];
xlRange4=['A2:',letter_str{1,size(outMatServe,2)},num2str(size(outMatServe,1)+1)];
xlRange5=['A2:',letter_str{1,size(outMatDemand,2)},num2str(size(outMatDemand,1)+1)];
xlRange6=['A2:',letter_str{1,size(outMatParameters,2)},num2str(size(outMatParameters,1)+1)];
xlRange7=['A2:',letter_str{1,size(outMatSummary,2)},num2str(size(outMatSummary,1)+1)];

%Til Excel
disp('Printing Sheet 1');
xlswrite(string_ex,outMatTruck,1,xlRange1);
disp('Printing Sheet 2');
xlswrite(string_ex,outMatUse,2,xlRange2);
disp('Printing Sheet 3');
xlswrite(string_ex,outMatTimeServed,3,xlRange3);
disp('Printing Sheet 4');
xlswrite(string_ex,outMatServe,4,xlRange4);
disp('Printing Sheet 5');
xlswrite(string_ex,outMatDemand,5,xlRange5);
disp('Printing Sheet 6');
xlswrite(string_ex,outMatParameters,6,xlRange6);
disp('Printing Sheet 7');
xlswrite(string_ex,outMatSummary,7,xlRange7);
if info_case==3
    xlswrite(string_ex,OnInventory,8);
end


disp('Main finished running');
if info_case==3
fprintf('\nGap Transporter Model: %d\n',gap_T);
end

fclose('all');









